Subject: Re: Relative submodule URLs vs. clone URL DWIMming

From: Junio C Hamano <[email-masked]>
Date: Sat, 30 Aug 2008 15:27:01 -0700

Johan Herland <[email-masked]> writes:

> ... But AFAICS, there's no way to get this information from the
> transport layer. I assume that the actual repo location is resolved on the
> remote side, and simply not communicated back to the local side.

Correct.

> If we simply resolve submodule URLs against the _repo_ (i.e. the real origin
> URL) and not the work tree (if any), we get results that are coupled to
> whether we use bare or non-bare repos: Take, for example, your use
> of "../<path>" to make submodules live outside the (bare) superproject. If I
> now create a non-bare clone of this, I must move the submodule repos _into_
> my work tree, so that the submodule repos are available, if someone tries to
> clone from me.

I personally feel that cases that involve cloning from non-bare
repositories (and in addition, DWIMmed repositories), with or without
nested submodules, are not worth supporting.